variables:
  IMAGE_TAG: $CI_COMMIT_BRANCH-$CI_COMMIT_SHORT_SHA

stages:
  - build
  - test
  - deploy
  - stop

image: busybox:latest

build:
  stage: build
  script:
    - mkdir vendor/
    - echo "one two" > vendor/hello.txt

test1:
  stage: test
  script:
    - echo "Do a test here"

deploy to stage:
  stage: deploy
  variables:
    TARGET_ENV: staging
  script:
  - echo "Do your deploy here to ${TARGET_ENV}"
  only:
  - master
  environment:
    name: staging
    on_stop: stop to staging
    auto_stop_in: 1 day

stop to staging:
  stage: stop
  variables:
    TARGET_ENV: staging
  script:
    - echo "STOP ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: staging
    action: stop

deploy to prod:
  stage: deploy
  variables:
    TARGET_ENV: prod
  script:
    - echo "Do your deploy here to ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: prod
    on_stop: stop to prod

stop to prod:
  stage: stop
  variables:
    TARGET_ENV: prod
  script:
    - echo "STOP ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: prod
    action: stop

deploy to preprod:
  stage: deploy
  variables:
    TARGET_ENV: preprod
  script:
    - echo "Do your deploy here to ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: preprod
    on_stop: stop to preprod

stop to preprod:
  stage: stop
  variables:
    TARGET_ENV: preprod
  script:
    - echo "STOP ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: preprod
    action: stop

deploy to production:
  stage: deploy
  variables:
    TARGET_ENV: production
  script:
    - echo "Do your deploy here to ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: production
    on_stop: stop to production

stop to production:
  stage: stop
  variables:
    TARGET_ENV: production
  script:
    - echo "STOP ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: production
    action: stop